"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var crc32 = require("crc32");
var AddChangeFile = /** @class */ (function () {
    function AddChangeFile(proUrl, toUrlMode, range) {
        if (!fs.existsSync(proUrl))
            return;
        var fromContents = fs.readFileSync(proUrl);
        var fromHash = crc32(fromContents);
        range = range || '0-500';
        var rangeSE = range.split('-');
        var max = Number(rangeSE[1]);
        var min = Number(rangeSE[0]);
        var toUrl;
        var oldJS = false;
        for (var i = max; i >= min; i--) {
            toUrl = toUrlMode.replace('#', String(i));
            if (fs.existsSync(toUrl)) {
                if (fromHash != crc32(fs.readFileSync(toUrl))) {
                    fs.writeFileSync(toUrlMode.replace('#', String(i + 1)), fromContents);
                }
                oldJS = true;
                break;
            }
        }
        if (!oldJS) {
            fs.writeFileSync(toUrlMode.replace('#', '1'), fromContents);
        }
        fs.unlinkSync(proUrl);
    }
    return AddChangeFile;
}());
function run(fromUrl, toUrlMode, range) {
    new AddChangeFile(fromUrl, toUrlMode, range);
}
exports.run = run;
