"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fileUtil = require("./tool/FileUtil");
var fs = require("fs");
var path = require("path");
var JsonYS = /** @class */ (function () {
    function JsonYS(args) {
        this._fixed = 2;
        var self = this;
        var baseUrl;
        var fixed;
        if (args[1]) {
            if (isNaN(args[1])) {
                baseUrl = args[1];
                fixed = Number(args[2]) || 2;
            }
            else {
                baseUrl = process.cwd();
                fixed = Number(args[1]) || 2;
            }
        }
        else {
            baseUrl = process.cwd();
            fixed = 2;
        }
        self._fixed = fixed;
        fileUtil.FileUtil.walkDir(baseUrl, self.onFile, null, self);
    }
    JsonYS.prototype.onFile = function (url) {
        var self = this;
        if (path.extname(url) != ".json")
            return;
        var data = JSON.parse(fs.readFileSync(url, 'utf-8'));
        self.transNumJson(data);
        fs.writeFileSync(url, JSON.stringify(data));
    };
    JsonYS.prototype.transNumJson = function (data) {
        for (var key in data) {
            if (data[key] instanceof Object || data[key] instanceof Array) {
                this.transNumJson(data[key]);
            }
            else {
                if (typeof (data[key]) == 'number') {
                    var bs = Math.pow(10, this._fixed);
                    data[key] = Math.round(data[key] * bs) / bs;
                }
            }
        }
    };
    return JsonYS;
}());
function run(args) {
    new JsonYS(args);
}
exports.run = run;
