"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fileUtil = require("./tool/FileUtil");
var fs = require("fs");
var path = require("path");
var LanTxtTurn = /** @class */ (function () {
    function LanTxtTurn(url) {
        this.lanTxtId = 0;
        this.lanStr2Key = {};
        this.newObj = {};
        this.txtAtt = [];
        this._allTsStr = '';
        this._keyObj = {};
        var self = this;
        self.lanObj = JSON.parse(fs.readFileSync(path.join(url, 'lanObj.json'), 'utf-8'));
        var curId = 0;
        for (var key in self.lanObj) {
            curId = Number(key.split('_').pop());
            self.lanStr2Key[self.lanObj[key]] = key;
            if (curId > self.lanTxtId)
                self.lanTxtId = curId;
        }
        self.lanTxtId += 1;
        fileUtil.FileUtil.walkDir(path.join(url, 'src'), self.onFile, null, self);
        self.txtAtt = [0];
        for (var i = 1; i < self.lanTxtId; i++) {
            if (self._allTsStr.indexOf('qufuLanTxt.k_' + i) < 0) {
                delete self.lanObj['k_' + i];
            }
            else {
                self.txtAtt.push(i);
            }
        }
        self.onFileAll();
        fs.writeFileSync(path.join(url, 'lanObj.json'), JSON.stringify(self.newObj, null, "	"));
    }
    LanTxtTurn.prototype.onFileAll = function () {
        var self = this;
        var txtAtt = this.txtAtt = [0];
        var i;
        var len;
        var idx = 1;
        self.newObj['k_0'] = self.lanObj['k_0'];
        for (i = 1; i < self.lanTxtId; i++) {
            if (self._allTsStr.indexOf('qufuLanTxt.k_' + i) >= 0) {
                txtAtt.push(i);
                self.newObj['k_' + idx] = self.lanObj['k_' + i];
                idx++;
            }
        }
        var oldStr = self._allTsStr;
        for (i = txtAtt.length - 1; i >= 0; i--) {
            self._allTsStr = self._allTsStr.replace(new RegExp('qufuLanTxt.k_' + txtAtt[i], "gi"), 'qufuLanTxt.k__' + i);
        }
        self._allTsStr = self._allTsStr.replace(new RegExp('qufuLanTxt.k__', "gi"), 'qufuLanTxt.k_');
        var tsArrStr = self._allTsStr.split('kohfwjhgfs');
        idx = 0;
        while (idx < tsArrStr.length) {
            if (tsArrStr[idx] && tsArrStr[idx + 1]) {
                fs.writeFileSync(tsArrStr[idx], tsArrStr[idx + 1]);
            }
            else {
                console.log('what?');
            }
            idx += 2;
        }
    };
    LanTxtTurn.prototype.onFile = function (url) {
        if (path.extname(url) != '.ts')
            return;
        var tsStr = fs.readFileSync(url, 'utf-8');
        var oldStr = tsStr;
        var reg = new RegExp("[\\u4E00-\\u9FFF]+", "g");
        var zsData = this.replaceZS(tsStr); //去掉注释
        var reArr = zsData.reArr;
        tsStr = this.replaceLan(zsData.str); //提取汉字
        for (var i = 0, len = reArr.length; i < len; i++) {
            tsStr = tsStr.replace('kohfwjh' + i + 'kohfwjh', reArr[i]);
        }
        if (oldStr != tsStr) {
            fs.writeFileSync(url, tsStr);
        }
        this._allTsStr += url + 'kohfwjhgfs' + tsStr + 'kohfwjhgfs';
    };
    LanTxtTurn.prototype.replaceZS = function (str) {
        var arr;
        var idx = 0;
        var zsArr = [];
        var reg = /\/\*(\s|.)*?\*\/|\/\/.*?[\r\n]|\/\/.*?$|console\.log\s*\(.*?\)|console\.warn\s*\(.*?\)|GameLog\.log\s*\(.*?\)|GameLog\.error\s*\(.*?\)|egret\.error\s*\(.*?\)|Error\s*\(.*?\)/gi;
        while (arr = reg.exec(str)) {
            var oldStr = arr[0];
            var newStr = void 0;
            newStr = "kohfwjh" + idx + "kohfwjh";
            zsArr.push(oldStr);
            str = str.replace(oldStr, newStr);
            reg.lastIndex -= oldStr.length - newStr.length;
            idx++;
        }
        return { str: str, reArr: zsArr };
    };
    LanTxtTurn.prototype.replaceLan = function (str) {
        var self = this;
        var arr;
        var zsArr = [];
        var reg = /'.*?'|".*?"/g;
        var regHZ = new RegExp("[\\u4E00-\\u9FFF]+", "g");
        var replace = false;
        while (arr = reg.exec(str)) {
            var oldStr = arr[0];
            regHZ.lastIndex = 0;
            replace = regHZ.test(oldStr);
            if (replace) {
                var ols = oldStr.substring(1, oldStr.length - 1);
                var key = self.lanStr2Key[ols];
                if (!key) {
                    key = self.lanStr2Key[ols] = 'k_' + self.lanTxtId;
                    self.lanObj[key] = ols;
                    self.lanTxtId++;
                }
                var newStr = 'qufuLanTxt.' + key;
                str = str.replace(oldStr, newStr);
                reg.lastIndex -= oldStr.length - newStr.length;
            }
        }
        return str;
    };
    return LanTxtTurn;
}());
// export function run(projectUrl: string): void {
new LanTxtTurn("D:\\work\\trunkHW\\qufu");
// }
