"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fileUtil = require("./tool/FileUtil");
var fs = require("fs");
var path = require("path");
var McTrans = /** @class */ (function () {
    function McTrans(jsUrl) {
        var self = this;
        self._jsUrl = jsUrl;
        self.trans();
    }
    McTrans.prototype.trans = function () {
        var self = this;
        fileUtil.FileUtil.walkDir(path.join(this._jsUrl), self.onFile, null, self);
    };
    McTrans.prototype.onFile = function (url) {
        var self = this;
        if (path.extname(url) != ".json")
            return;
        var jsStr = fs.readFileSync(url, 'utf-8');
        var mcInfo = JSON.parse(jsStr);
        var newMcInfo = self.transMc(mcInfo);
        if (newMcInfo) {
            var newJs = JSON.stringify(newMcInfo);
            fs.writeFileSync(url, newJs);
        }
        else {
            console.log(mcInfo);
            console.log("错误文件Url = ", url);
        }
    };
    McTrans.prototype.transMc = function (mcInfo) {
        var self = this;
        var url;
        var index;
        var indexStr;
        var frame;
        var resInfo;
        var mc1Data = mcInfo.mc;
        if (mc1Data) {
            var mcData = void 0;
            for (var key in mc1Data) {
                mcData = mc1Data[key];
            }
            var frames_1 = mcData.frames;
            var newMcInfo = { len: 0, speed: 0, subtexture: {} };
            newMcInfo.speed = mcData.frameRate;
            for (var i = 0, len = frames_1.length; i < len; i++) {
                frame = frames_1[i];
                index = i + 1;
                resInfo = mcInfo.res[frame.res];
                indexStr = index >= 10 ? "0" + index : "00" + index;
                newMcInfo.subtexture[indexStr] = { "0": resInfo.x, "1": resInfo.y, "2": resInfo.w, "3": resInfo.h, "4": frame.x, "5": frame.y };
            }
            newMcInfo.len = frames_1.length;
            return newMcInfo;
        }
        return null;
    };
    return McTrans;
}());
function run(jsUrl) {
    new McTrans(jsUrl);
}
exports.run = run;
