"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var charset = "utf-8";
var fs = require("fs");
var path = require("path");
/** 遍历文件夹（返回是否是文件夹） */
function walkDir(url, onFile, tar) {
    var stats = fs.statSync(url);
    if (stats.isDirectory()) {
        var files = fs.readdirSync(url);
        for (var i = 0, len = files.length; i < len; i++) {
            walkDir(path.join(url, files[i]), onFile, tar);
        }
        return true;
    }
    else {
        onFile.call(tar, url);
        return false;
    }
}
exports.walkDir = walkDir;
// 创建文件夹
function mkdirsSync(url) {
    if (!fs.existsSync(url)) {
        mkdirsSync(path.dirname(url));
        fs.mkdirSync(url);
    }
}
exports.mkdirsSync = mkdirsSync;
/** 删除文件夹或文件夹 */
function existsSync(url) {
    if (walkDir(url, function (fileUrl) {
        fs.unlinkSync(fileUrl);
    }, this))
        fs.rmdirSync(url);
}
exports.existsSync = existsSync;
/** 清空文件夹 */
function clearSync(url) {
    existsSync(url);
    mkdirsSync(url);
}
exports.clearSync = clearSync;
/** 返回文件完整名 */
function filename(url) {
    return path.normalize(path.join(path.dirname(url), path.basename(url, path.extname(url))));
}
exports.filename = filename;
