"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var os = require("os");
var iconv = require("iconv-lite");
var fileUtil = require("./../tool/FileUtil");
var exec = require('child_process').exec;
/**自动生成代码类 */
var AutoCodeEui = /** @class */ (function () {
    /**
     * 自动生成代码类
     * @param rootUrl  当前项目的根目录  如：D:\workspace\yscq
     * @param exmlName 当前exml文件的名字  可带客不带.exml  如ZHTaskSkin 或 ZHTaskSkin.exml
     *                 特殊： -config 打开配置文件
     *                       -module 打开模板目录
     */
    function AutoCodeEui(rootUrl, exmlName) {
        this.curExmlPath = ""; //当前exml的路径
        this.rootpath = rootUrl;
        this.codeCreate = new CreateCode(this.rootpath);
        if (exmlName.indexOf(".exml") != -1)
            exmlName = exmlName.replace(".exml", "");
        this.curExmlName = exmlName;
        if (exmlName == "-module") {
            this.euiOpenCodeModule();
        }
        else if (exmlName == "-config") {
            this.euiOutCodeConfig();
        }
        else if (exmlName == "-help") {
            console.log("\nnodetool -eui -config   \u6253\u5F00\u914D\u7F6E\u6587\u4EF6\nnodetool -eui -module   \u6253\u5F00\u6A21\u677F\u6587\u4EF6\u5939\nnodetool -eui -help     \u663E\u793A\u5E2E\u52A9\nnodetool -eui \u76AE\u80A4\u540D    \u751F\u6210\u76AE\u80A4\u7684\u4EE3\u7801\n    \u76AE\u80A4\u540D  \n        1. exml\u7684\u76F8\u5BF9\u8DEF\u5F84\u5982\uFF1A  nodetool -eui resourceassetsmodulechatChatSkin.exml\n        2. exml\u7684\u6587\u4EF6\u540D \u5982\uFF1A   nodetool -eui ChatSkin\n        3. exml\u6587\u4EF6\u5168\u540D  \u5982\uFF1A  nodetool -eui ChatSkin.exml\n        4. exml\u6A21\u7CCA\u5339\u914D  \u5982\uFF1A  nodetool -eui Chat*  \uFF08\u614E\u7528\uFF09\n\n    \u76AE\u80A4\u547D\u540D\u89C4\u5219\n        1. \u5982\u679C\u76AE\u80A4\u6587\u4EF6\u540D\u4E2D\u5E26\u6709  MainPanel \uFF08\u529F\u80FD\u7684\u4E3B\u754C\u9762\uFF09 \u7684\u8BDD  \u7A0B\u5E8F\u751F\u6210 \uFF1A\n            ViewUI\uFF08\u8986\u76D6\uFF09  \n            MainView\uFF08\u53EA\u751F\u6210\u4E00\u6B21\uFF09  \n            Module\uFF08\u53EA\u751F\u6210\u4E00\u6B21\uFF09  \n            Mediator\uFF08\u53EA\u751F\u6210\u4E00\u6B21\uFF09  \n            Model\uFF08\u53EA\u751F\u6210\u4E00\u6B21\uFF09\n        2. \u5982\u679C\u76AE\u80A4\u540D\u4E2D\u5305\u542B  Panel(\u5F39\u7A97\u754C\u9762)  \u7A0B\u5E8F\u751F\u6210\uFF1A\n            ViewUI\uFF08\u8986\u76D6\uFF09 \n            Panel \uFF08\u53EA\u751F\u6210\u4E00\u6B21\uFF09\n        3. \u5982\u679C\u76AE\u80A4\u540D\u4E2D\u5305\u542B  Render\uFF08\u5217\u8868\u9879\uFF09 \u7A0B\u5E8F\u751F\u6210\uFF1A\n            RenderUI \uFF08\u8986\u76D6\uFF09\n            Render  \uFF08\u53EA\u751F\u6210\u4E00\u6B21\uFF09\n        4. \u5982\u679C\u76AE\u80A4\u540D\u4E2D\u5305\u542B View(\u53EA\u662F\u754C\u9762) \u6216\u8005\u4E0A\u8FF0\u60C5\u51B5\u90FD\u4E0D\u7B26\u5408 \u7A0B\u5E8F\u751F\u6210\uFF1A\n            ViewUI \uFF08\u8986\u76D6\uFF09\n\n    \u4F7F\u7528\u8BF4\u660E\uFF1A\n        1.\u53EF\u4EE5\u5148\u8F93\u5165  nodetool -eui -config  \u6253\u5F00\u914D\u7F6Eapp.config.json  \u4FEE\u6539 auth\u4E3A\u81EA\u5DF1\u7684\u540D\u5B57 \uFF08\u5982\u679C\u4E0D\u586B\u9ED8\u8BA4\u4F7F\u7528\u8BA1\u7B97\u673A\u540D\uFF09\n        2.\u5728\u7A0B\u5E8F\u7684\u8DDF\u76EE\u5F55\u4E0B\u6267\u884C\u547D\u4EE4  \u5982 D:workspaceyscq> nodetool -eui Chat*Render\n            ");
        }
        else {
            var exmlPath = path.join(this.rootpath, exmlName + ".exml");
            if (!fs.existsSync(exmlPath)) //如果不存在则去项目的resuoce中去找下
             {
                var exmlDir = path.join(this.rootpath, "resource/");
                if (fs.existsSync(exmlDir))
                    fileUtil.FileUtil.walkDir(exmlDir, this.checkFile, undefined, this);
                else
                    console.log("资源目录不存在：" + exmlDir);
            }
            else {
                this.checkFile(exmlPath, false);
            }
        }
    }
    /**AutoCodeEui入口 */
    AutoCodeEui.prototype.euiOutCode = function () {
        var filePath = this.curExmlPath; //.document.fileName;
        var fileName = filePath.substring(0, filePath.lastIndexOf("\\"));
        var ext = path.extname(filePath);
        if (ext != '.exml') {
            console.log("当前不是Eui文件" + ext);
            return;
        }
        var content = fs.readFileSync(filePath, 'utf-8');
        var ids = this.findIds(content);
        // log("当前打开文件："+ids.join(" "));
        var euiinfo = {};
        euiinfo.path = filePath;
        euiinfo.content = content;
        euiinfo.ids = ids;
        var pathinfo = path.parse(filePath);
        var filename = euiinfo.fileName = pathinfo.name;
        var filearr = filename.match(/^(.*?)EuiSkin$/i);
        if (!filearr) {
            filearr = filename.match(/^(.*?)Skin$/i);
        }
        if (filearr)
            euiinfo.baseClsName = filearr[1];
        else
            euiinfo.baseClsName = filename;
        var skinNameReg = /\s+class=["'](\w+)["']\s+/gi;
        var skinNameArr = skinNameReg.exec(content);
        if (skinNameArr && skinNameArr.length > 0) {
            euiinfo.skinName = skinNameArr[1];
        }
        else {
            euiinfo.skinName = euiinfo.baseClsName;
        }
        euiinfo.baseClsName = euiinfo.baseClsName;
        var pathdirarr = path.normalize(pathinfo.dir).split(path.sep);
        euiinfo.parentDir = pathdirarr[pathdirarr.length - 1];
        this.codeCreate.createCode(euiinfo);
    };
    /**
     * 查找exml中的ids  返回  IdInfo[]
     */
    AutoCodeEui.prototype.findIds = function (content) {
        var ids = [];
        var lines = content.split(/[\r\n(\r\n)]/);
        var nss = this.findNameSp(lines.join(" "));
        var idexp = / id=\"(.*?)\"/ig;
        var uimodule = this.is_eui(content) ? "eui." : 'egret.gui.';
        lines.forEach(function (line) {
            var temp = line.match(idexp);
            if (temp && temp.length > 0) {
                var clsDef = line.match(/<(.+?):(.+?) /);
                if (!clsDef || clsDef.length < 3)
                    return;
                var clsMod = void 0;
                if (clsDef[1] == "e") {
                    clsMod = uimodule;
                }
                else {
                    clsMod = nss[clsDef[1]];
                    if (!clsMod)
                        return;
                    clsMod = clsMod.substring(0, clsMod.length - 1);
                }
                var clsName = clsDef[2];
                var id = temp[0].replace(' id=', "").replace('"', '').replace('"', '');
                ids.push({ name: id, module: clsMod, clsName: clsName });
            }
        });
        return ids;
    };
    /**查找命名空间 */
    AutoCodeEui.prototype.findNameSp = function (text) {
        var map = {};
        var names = text.match(/xmlns:(.+?)="(.+?)"/g);
        names.forEach(function (name) {
            var result = name.match(/xmlns:(.+?)="(.+?)"/);
            if (result.length == 3) {
                map[result[1]] = map[result[2]];
            }
        });
        return map;
    };
    /**是否是eui配置 */
    AutoCodeEui.prototype.is_eui = function (text) {
        if (text.indexOf('xmlns:e="http://ns.egret.com/eui"') > 0)
            return true;
        return false;
    };
    /**打开EuiAutoCode 的配置文件 */
    AutoCodeEui.prototype.euiOutCodeConfig = function () {
        console.log(this.codeCreate.getConfigPath());
        exec('explorer.exe /select, ' + this.codeCreate.getConfigPath());
    };
    AutoCodeEui.prototype.euiOpenCodeModule = function () {
        console.log(this.codeCreate.getModulePath());
        exec('explorer.exe ' + this.codeCreate.getModulePath());
    };
    AutoCodeEui.prototype.checkFile = function (url, needCheck) {
        if (needCheck === void 0) { needCheck = true; }
        var fileInfo = path.parse(url);
        var tempName = this.curExmlName;
        if (tempName.indexOf("*") != -1) {
            var reg = new RegExp(tempName.replace(/\*/gi, ".*?"), "gi");
            if (reg.exec(fileInfo.name)) {
                tempName = fileInfo.name;
            }
        }
        if (fileInfo.name == tempName || !needCheck) {
            if (!needCheck) //只有在使用全路径的时候有效
                this.curExmlName = fileInfo.name;
            this.curExmlPath = url;
            console.log("开始处理  " + fileInfo.name);
            this.euiOutCode();
        }
    };
    return AutoCodeEui;
}());
exports.AutoCodeEui = AutoCodeEui;
/**
 * 创建生成代码类
 */
var CreateCode = /** @class */ (function () {
    function CreateCode(rootpath) {
        this.rootpath = ""; //项目路径
        this.moduleCodePath = "";
        this.modulepath = path.join(__dirname, "./../../resource/autocodeeui", "module");
        this.configpath = path.join(__dirname, "./../../resource/autocodeeui/config/app.config.json");
        this.rootpath = rootpath;
    }
    CreateCode.prototype.getConfigPath = function () {
        return this.configpath;
    };
    CreateCode.prototype.getModulePath = function () {
        return this.modulepath;
    };
    /**
     * 创建程序代码入口
     */
    CreateCode.prototype.createCode = function (info) {
        if (!fs.existsSync(this.configpath)) {
            console.log("请添加插件配置" + this.configpath);
            return;
        }
        var configtxt = fs.readFileSync(this.configpath, 'utf-8');
        this.config = JSON.parse(configtxt);
        this.moduleCodePath = this.config.moduleCodePath;
        var varsDic = {};
        varsDic["auth"] = this.config.auth || this.getHostName();
        var date = new Date();
        varsDic["time"] = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate() + " " + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
        varsDic['path'] = path.relative(this.rootpath, info.path);
        varsDic['fileName'] = info.fileName;
        varsDic['baseClsName'] = info.baseClsName;
        varsDic['skinName'] = info.skinName;
        var varids = "";
        var interfaceIds = "";
        var ids = info.ids;
        var createIdDic = {};
        for (var i = 0; i < ids.length; i++) {
            var id = ids[i];
            var preAdd = "";
            if (createIdDic[id.name])
                preAdd = "//";
            varids += preAdd + "public " + id.name + ":" + id.module + id.clsName + ";\n\t";
            interfaceIds += preAdd + id.name + "?:any;\n\t";
            createIdDic[id.name] = true;
        }
        varsDic['varids'] = varids;
        varsDic['interfaceIds'] = interfaceIds;
        var create = this.findModule(this.config, info.fileName);
        var moduleIds = create.usemodule.split(",");
        var keys = create.keyword.split("|");
        for (var j = 0; j < keys.length; j++) {
            if (info.baseClsName.indexOf(keys[j]) != -1) {
                varsDic["shortName"] = info.baseClsName.replace(keys[j], "");
                break;
            }
        }
        if (!varsDic["shortName"])
            varsDic["shortName"] = info.baseClsName;
        varsDic["moduleID"] = this.getModuleID(varsDic["shortName"]);
        for (var i = 0; i < moduleIds.length; i++) {
            var mod = this.config.module[+moduleIds[i]];
            if (!mod) {
                console.log("app.config.json当前没有配置" + moduleIds[i] + "对应的配置");
                continue;
            }
            this.createFileByModuld(mod, info, varsDic);
        }
    };
    CreateCode.prototype.getHostName = function () {
        var name = os.hostname();
        var buff = new Buffer(name, "binary");
        name = iconv.decode(buff, "gbk");
        return name;
    };
    /**根据module名字生成ModuleID  生成规则 moduleName原始字符中大写前加上_并把所有字符转成大写 */
    CreateCode.prototype.getModuleID = function (moduleName) {
        var idkey = "";
        for (var i = 0; i < moduleName.length; i++) {
            var char = moduleName[i].toLocaleUpperCase();
            if (char == moduleName[i]) {
                if (idkey)
                    idkey = idkey + "_";
            }
            idkey += char;
        }
        return idkey;
    };
    /**根据eui的文件名找到对应处理的CreateInfo 如果没有找到则用配置中默认的 */
    CreateCode.prototype.findModule = function (config, fileName) {
        var creates = config.create;
        for (var i = 0; i < creates.length; i++) {
            var create = creates[i];
            var keys = create.keyword.split("|");
            for (var j = 0; j < keys.length; j++) {
                if (fileName.indexOf(keys[j]) != -1) {
                    return create;
                }
            }
        }
        return config.create[config.defaultcreate];
    };
    /**根据ModuleInfo 生成对应的文件 */
    CreateCode.prototype.createFileByModuld = function (modinfo, info, varsDic) {
        var keyReg = /\[(.*?)\]/gi;
        var keyArr = keyReg.exec(modinfo.outdir);
        var outpath = path.join(this.rootpath, this.moduleCodePath + info.parentDir + "/" + modinfo.outdir + "/" + varsDic["shortName"] + modinfo.name + "." + modinfo.fileType);
        if (keyArr) {
            outpath = path.join(this.rootpath, modinfo.outdir.replace(keyArr[0], keyArr[1]).trim(), varsDic["shortName"] + modinfo.name + "." + modinfo.fileType);
        }
        var exists = fs.existsSync(outpath);
        if (!modinfo.override && exists) {
            // console.log("文件已存在不用生成")
            console.log("文件已存在不用生成");
            return;
        }
        var areaDic = {};
        if (exists) //如果存在保护域则先记录保护域的内容
         {
            var reg = /\/\*+area(\d+)--start\*+\/([\s\S]*)\/\*+area\1--end\*+\//gi;
            var oldContent = fs.readFileSync(outpath, 'utf-8');
            var rect = void 0;
            while (rect = reg.exec(oldContent)) {
                areaDic[rect[1]] = rect[2];
            }
        }
        var viewcode = this.createCodeTxt(path.join(this.modulepath, modinfo.file), info, varsDic);
        if (exists) //将保护域的内容在重新放到生成的文件中
         {
            for (var key in areaDic) {
                var reg = new RegExp("(\\/\\*+area" + key + "--start\\*+\\/)([\\s\\S]*)(\\/\\*+area" + key + "--end\\*+\\/)", "gi");
                viewcode = viewcode.replace(reg, "$1" + areaDic[key] + "$3");
            }
        }
        this.saveFile(outpath, viewcode);
        console.log("创建成功" + outpath);
    };
    /**保存文件， 如果文件夹不存在则会创建文件夹 */
    CreateCode.prototype.saveFile = function (path, data) {
        this.checkOrCreateDir(path);
        fs.writeFileSync(path, data, { encoding: "utf-8" });
    };
    /**生成模板替换后的文本*/
    CreateCode.prototype.createCodeTxt = function (moduleFilePath, info, varDic) {
        if (!fs.existsSync(moduleFilePath)) {
            console.log("当前文件不存在" + moduleFilePath);
            return "";
        }
        var content = fs.readFileSync(moduleFilePath, 'utf-8');
        var keyReg = /\$\{(.*?)\}/gi;
        var keyArr;
        while (keyArr = keyReg.exec(content)) {
            content = content.split(keyArr[0]).join(varDic[keyArr[1]]);
        }
        return content;
    };
    /**创建新的文件夹 */
    CreateCode.prototype.checkOrCreateDir = function (filePath) {
        filePath = path.normalize(filePath);
        var arr = path.parse(filePath).dir.split(path.sep);
        if (!arr || arr.length == 0)
            return;
        var dirpath = arr[0];
        for (var i = 1; i < arr.length; i++) {
            dirpath = dirpath + path.sep + arr[i];
            if (!fs.existsSync(dirpath)) {
                fs.mkdirSync(dirpath);
            }
        }
    };
    return CreateCode;
}());
function run(rootUrl, exmlName) {
    new AutoCodeEui(rootUrl, exmlName);
    console.log("执行完毕");
}
exports.run = run;
